﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Raspberry Pi Experiment
'Class Experiment
Sub Class_Globals
	Private ws As WebSocket
	Private name As String						'The username for this connection
	'
	Private btnTimerSwitch As JQueryElement		'Switch to start/stop the timer. Defined in index.html as <a class="w3-btn w3-theme-l3" id="btnhelloworld">Click me!</a>
	Private tftimerinterval As JQueryElement	'Blinkinterval in ms
	Private TimerSwitchState As Boolean			'Flag to show the switch state being True = ON or False = OFF
	Private SwitchCounter As Int				'Lets track how many timers the LED has blinked
	'Led
	Private lblLedStatus As JQueryElement		'Label showing Welcome. Defined in index.html as <div id="lblhelloworld"></div>
	'Timer
	Private Timer1 As Timer
End Sub

Public Sub Initialize
	
End Sub

'The user connects to the websocket via browser <URL>:51042. The html file www/index.html is displayed.
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	Log("WebSocket_Connected : Start = " & ws.Session.Id)
	'Capture the session id as the name
	If ws.Session.HasAttribute("name") = False Then
		name = ws.Session.Id
		name = WebUtils.EscapeHtml(name.Trim)
		ws.Session.SetAttribute("name", name)
		Controller.AvoidDuplicates.Put(name.ToLowerCase, name)
		Log("Name New")
	Else
		Log("Name Found")
		name = ws.Session.GetAttribute("name")
		'Remove the attribute
		ws.Session.RemoveAttribute("name")
	End If
	CallSubDelayed3(Controller, "NewConnection", Me, name)
	'Update the selectors and set some initial velues
	btnTimerSwitch.SetHtml("Switch the Timer <b>ON</b>")
	TimerSwitchState = False
	SwitchCounter = 0
	ws.Flush
	Log("WebSocket_Connected : End")
End Sub

Private Sub WebSocket_Disconnected
	Log("WebSocket_Disconnected :: Start")
	If name <> "" Then CallSubDelayed3(Controller, "Disconnect", Me, name)
	Log("WebSocket_Disconnected :: End")
End Sub

'Handle the timer tickets
Sub LEDTimer_Tick
	Log("LEDTimer_Tick :: Start")
	'Increase the counter
	SwitchCounter = SwitchCounter + 1
	'Change the Pin1 state
	CallSubDelayed2(Controller, "LEDChangeState", SwitchCounter)
	Log("LEDTimer_Tick :: End")
End Sub

'
Sub LEDUpdateStatus(status As String)
	lblLedStatus.setHtml(status)
	'Do not forget to trigger flushing the outputsteam. This will refresh the page.
	ws.Flush
End Sub

Sub btnTimerSwitch_click(params As Map)
'	Log("btnSwitchLed_click :: Start = Parameter: " & params.Size)
	If TimerSwitchState = False Then
		'Get the interval from the inputfield. Do checks if isnumber and if value > 0
		Dim intervals As String = tftimerinterval.GetVal.Value
		If IsNumber(intervals) = False Then
			lblLedStatus.setHtml("Wrong Number specified for the Timer Interval.")
			ws.Flush
			Return
		End If
		Dim interval As Long = intervals
		If interval <= 0 Then
			lblLedStatus.setHtml("The Timer Interval must be greater 0 ms.")
			ws.Flush
			Return
		End If
		'Init the timer with the interval specified and update the switch label
		Timer1.Initialize("LEDTimer", interval)
		TimerSwitchState = True
		btnTimerSwitch.SetHtml("Switch the Timer <b>OFF</b>")
		SwitchCounter = 0
		lblLedStatus.setHtml("The Timer is started.")
	Else
		TimerSwitchState = False
		btnTimerSwitch.SetHtml("Switch the Timer <b>ON</b>")
		lblLedStatus.setHtml("Nothing to do as the Timer is switched OFF.")
	End If
	ws.Flush
	'Set the timer
	Timer1.Enabled = TimerSwitchState 
'	Log("btnSwitchLed_click :: End")
End Sub
